> ## Documentation Index
> Fetch the complete documentation index at: https://docs.serval.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Workflow Approval Procedures

> List all approval procedures for a workflow.



## OpenAPI

````yaml /sections/api-reference/openapi-spec-v2.yaml get /v2/workflows/{workflow_id}/approval-procedures
openapi: 3.1.0
info:
  title: Serval Public API
  description: Serval Public API
  contact:
    name: Serval
    url: https://serval.com
    email: support@serval.com
  license:
    name: Serval License
    url: https://serval.com/license
  version: 2.0.0
servers:
  - url: https://public.api.serval.com
security:
  - BearerAuth: []
tags:
  - name: Access Policy API
  - name: Access Policy Approval Procedure API
  - name: Access Profile API
  - name: Access Relationship API
  - name: Access Request API
  - name: Agent API
  - name: App Instance API
  - name: App Resource API
  - name: App Resource Role API
  - name: Approval Delegation API
  - name: Approval Request API
  - name: Audit Log API
  - name: Change Blackout API
  - name: Change Model API
  - name: Custom Field API
  - name: Custom Service API
  - name: Entity API
  - name: Entity Field Mapping API
  - name: Entity Ingestion Config API
  - name: Entity Type API
  - name: Folder API
  - name: Group API
  - name: Guidance API
  - name: Help Agent API
  - name: Journey API
  - name: Knowledge API
  - name: Knowledge Base API
  - name: Report API
  - name: SLA API
  - name: Schedule API
  - name: Tag API
  - name: Team API
  - name: Team User API
  - name: Ticket API
  - name: Topic API
  - name: User API
  - name: User Relationship API
  - name: Workflow API
  - name: Workflow Approval Procedure API
  - name: Workflow Run API
paths:
  /v2/workflows/{workflow_id}/approval-procedures:
    get:
      tags:
        - Workflow Approval Procedure API
      summary: List Workflow Approval Procedures
      description: List all approval procedures for a workflow.
      operationId: svrelay.publicv2.PublicAPIServiceV2.ListWorkflowApprovalProcedures
      parameters:
        - name: workflow_id
          in: path
          required: true
          schema:
            type: string
            title: workflow_id
            description: The ID of the workflow to list approval procedures for.
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/svflow.publicapi.ListWorkflowApprovalProceduresResponse
        default:
          description: Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/connect.error'
      security:
        - BearerAuth: []
components:
  schemas:
    svflow.publicapi.ListWorkflowApprovalProceduresResponse:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/svflow.pubapimodels.WorkflowApprovalProcedure'
          title: data
          description: The list of approval procedures (typically 0 or 1).
          x-stainless-terraform-configurability: optional
      title: ListWorkflowApprovalProceduresResponse
      additionalProperties: false
    connect.error:
      type: object
      properties:
        code:
          type: string
          examples:
            - not_found
          enum:
            - canceled
            - unknown
            - invalid_argument
            - deadline_exceeded
            - not_found
            - already_exists
            - permission_denied
            - resource_exhausted
            - failed_precondition
            - aborted
            - out_of_range
            - unimplemented
            - internal
            - unavailable
            - data_loss
            - unauthenticated
          description: >-
            The status code, which should be an enum value of
            [google.rpc.Code][google.rpc.Code].
          x-stainless-terraform-configurability: optional
        message:
          type: string
          description: >-
            A developer-facing error message, which should be in English. Any
            user-facing error message should be localized and sent in the
            [google.rpc.Status.details][google.rpc.Status.details] field, or
            localized by the client.
          x-stainless-terraform-configurability: optional
        detail:
          $ref: '#/components/schemas/google.protobuf.Any'
          x-stainless-terraform-configurability: optional
      title: Connect Error
      additionalProperties: true
      description: >-
        Error type returned by Connect:
        https://connectrpc.com/docs/go/errors/#http-representation
    svflow.pubapimodels.WorkflowApprovalProcedure:
      type: object
      properties:
        id:
          type: string
          title: id
          description: The ID of the workflow approval procedure.
          readOnly: true
          x-stainless-terraform-configurability: computed
        workflowId:
          type: string
          title: workflow_id
          description: The ID of the workflow this approval procedure belongs to.
          x-stainless-terraform-configurability: optional
        steps:
          type: array
          items:
            $ref: '#/components/schemas/svflow.pubapimodels.ApprovalStep'
          title: steps
          description: The steps in the approval procedure.
          x-stainless-terraform-configurability: optional
      title: WorkflowApprovalProcedure
      additionalProperties: false
    google.protobuf.Any:
      type: object
      properties:
        type:
          type: string
          x-stainless-terraform-configurability: optional
        value:
          type: string
          format: binary
          x-stainless-terraform-configurability: optional
        debug:
          type: object
          additionalProperties: true
          x-stainless-terraform-configurability: optional
      additionalProperties: true
      description: >-
        Contains an arbitrary serialized message along with a @type that
        describes the type of the serialized message.
    svflow.pubapimodels.ApprovalStep:
      type: object
      properties:
        id:
          type: string
          title: id
          description: The ID of the approval step.
          readOnly: true
          x-stainless-terraform-configurability: computed
        allowSelfApproval:
          type: boolean
          title: allow_self_approval
          description: |-
            Whether the step can be approved by the requester themselves.
             optional so server can distinguish "not set" from "explicitly false"
             (DB defaults to TRUE; proto3 defaults bool to false)
          nullable: true
          x-stainless-terraform-configurability: computed_optional
        approvers:
          type: array
          items:
            $ref: '#/components/schemas/svflow.pubapimodels.Approver'
          title: approvers
          description: |-
            Exactly one of approvers or custom_workflow must be set.
             Mutual exclusivity validated server-side.
          x-stainless-terraform-configurability: optional
        customWorkflow:
          $ref: '#/components/schemas/svflow.pubapimodels.CustomWorkflowConfig'
          title: custom_workflow
          nullable: true
          x-stainless-terraform-configurability: optional
        approverJustificationMode:
          type: string
          title: approver_justification_mode
          description: >-
            Controls whether approvers are asked for a justification when
            deciding this step.
             Valid values: "not_requested", "optional", "required",
             "required_for_approval", "required_for_denial". Empty defaults to
             "not_requested". The "_for_approval" and "_for_denial" variants make the
             justification mandatory only when approving or denying, respectively.
          x-stainless-terraform-configurability: computed_optional
      title: ApprovalStep
      additionalProperties: false
    svflow.pubapimodels.Approver:
      type: object
      oneOf:
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.AppOwner'
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.Group'
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.Manager'
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.ResourceOwner'
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.RoleOwner'
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.TeamOwner'
        - $ref: '#/components/schemas/svflow.pubapimodels.Approver.User'
      title: Approver
      description: An approver source with notification preference.
    svflow.pubapimodels.CustomWorkflowConfig:
      type: object
      properties:
        workflowId:
          type: string
          title: workflow_id
          description: The ID of the workflow to execute.
          x-stainless-terraform-configurability: optional
      title: CustomWorkflowConfig
      additionalProperties: false
      description: >-
        Configuration for a custom workflow that determines approvers or
        auto-approves.
    svflow.pubapimodels.Approver.AppOwner:
      type: object
      title: App Owner
      properties:
        appOwner:
          $ref: '#/components/schemas/svflow.pubapimodels.AppOwnerApprover'
          title: app_owner
          description: >-
            App-instance owners as approvers. Only valid for access policy
            approval procedures.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - appOwner
      additionalProperties: false
      description: >-
        App-instance owners as approvers. Only valid for access policy approval
        procedures.
    svflow.pubapimodels.Approver.Group:
      type: object
      title: Group
      properties:
        group:
          $ref: '#/components/schemas/svflow.pubapimodels.GroupApprover'
          title: group
          description: A Serval group as approvers.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - group
      additionalProperties: false
      description: A Serval group as approvers.
    svflow.pubapimodels.Approver.Manager:
      type: object
      title: Manager
      properties:
        manager:
          $ref: '#/components/schemas/svflow.pubapimodels.ManagerApprover'
          title: manager
          description: The requester's manager as an approver.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - manager
      additionalProperties: false
      description: The requester's manager as an approver.
    svflow.pubapimodels.Approver.ResourceOwner:
      type: object
      title: Resource Owner
      properties:
        resourceOwner:
          $ref: '#/components/schemas/svflow.pubapimodels.ResourceOwnerApprover'
          title: resource_owner
          description: >-
            Resource owners as approvers. Only valid for access policy approval
            procedures.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - resourceOwner
      additionalProperties: false
      description: >-
        Resource owners as approvers. Only valid for access policy approval
        procedures.
    svflow.pubapimodels.Approver.RoleOwner:
      type: object
      title: Role Owner
      properties:
        roleOwner:
          $ref: '#/components/schemas/svflow.pubapimodels.RoleOwnerApprover'
          title: role_owner
          description: >-
            Role (entitlement) owners as approvers. Only valid for access policy
            approval procedures.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - roleOwner
      additionalProperties: false
      description: >-
        Role (entitlement) owners as approvers. Only valid for access policy
        approval procedures.
    svflow.pubapimodels.Approver.TeamOwner:
      type: object
      title: Team Owner
      properties:
        teamOwner:
          $ref: '#/components/schemas/svflow.pubapimodels.TeamOwnerApprover'
          title: team_owner
          description: >-
            Team owners as approvers. Only valid for access policy approval
            procedures.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - teamOwner
      additionalProperties: false
      description: >-
        Team owners as approvers. Only valid for access policy approval
        procedures.
    svflow.pubapimodels.Approver.User:
      type: object
      title: User
      properties:
        user:
          $ref: '#/components/schemas/svflow.pubapimodels.UserApprover'
          title: user
          description: A specific user as an approver.
          x-stainless-terraform-configurability: optional
        notify:
          type: boolean
          title: notify
          description: Whether to notify this approver when the step is pending.
          x-stainless-terraform-configurability: computed_optional
      required:
        - user
      additionalProperties: false
      description: A specific user as an approver.
    svflow.pubapimodels.AppOwnerApprover:
      type: object
      title: AppOwnerApprover
      additionalProperties: false
      description: |-
        The owners of the app instance the requested role belongs to.
         Only valid for access policy approval procedures.
    svflow.pubapimodels.GroupApprover:
      type: object
      properties:
        groupId:
          type: string
          title: group_id
          description: The ID of the Serval group.
          x-stainless-terraform-configurability: optional
      title: GroupApprover
      additionalProperties: false
      description: A Serval group as an approver.
    svflow.pubapimodels.ManagerApprover:
      type: object
      title: ManagerApprover
      additionalProperties: false
      description: The requester's manager as an approver.
    svflow.pubapimodels.ResourceOwnerApprover:
      type: object
      title: ResourceOwnerApprover
      additionalProperties: false
      description: |-
        The owners of the resource the requested role belongs to.
         Only valid for access policy approval procedures.
    svflow.pubapimodels.RoleOwnerApprover:
      type: object
      title: RoleOwnerApprover
      additionalProperties: false
      description: |-
        The owners of the requested role (entitlement) itself.
         Only valid for access policy approval procedures.
    svflow.pubapimodels.TeamOwnerApprover:
      type: object
      title: TeamOwnerApprover
      additionalProperties: false
      description: |-
        The owners of the team that owns the requested role's app instance.
         Only valid for access policy approval procedures.
    svflow.pubapimodels.UserApprover:
      type: object
      properties:
        userId:
          type: string
          title: user_id
          description: The ID of the user.
          x-stainless-terraform-configurability: optional
      title: UserApprover
      additionalProperties: false
      description: A specific user as an approver.
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````